long double angle_restrict_pos(const long double theta)
{
  /* synthetic extended precision constants */
  const long double P1 = 3.1415926535897930000000000000000000000000L;
  const long double P2 = 0.2384626433832790000000000000000000000000e-15L;
  const long double P3 = 0.5028841971693990000000000000000000000000e-30L;
  //const long double P4 = 0.375105820974944e-45L;
  /*
  const long double P1 = 4 * 7.85398125648498535156e-01L;
  const long double P2 = 4 * 3.77489470793079817668e-08L;
  const long double P3 = 4 * 2.69515142907905952645e-15L;*/
  const long double TwoPi = 2*(P1 + P2 + P3);

  const long double y = 2*floorl(theta/TwoPi);

  long double r = (((theta - y*P1) - y*P2) - y*P3);

  if(r > TwoPi) {r = (((r-2*P1)-2*P2)-2*P3); }  /* r-TwoPi */
  else if (r < 0) { /* may happen due to FP rounding */
    r = (((r+2*P1)+2*P2)+2*P3); /* r+TwoPi */
  }

  return r;
};




static long double zeta_2n_minus1[40]={
0.6449340668482264364724151666460251892189L,
0.08232323371113819151600369654116790277475L,
0.01734306198444913971451792979092052790182L,
0.004077356197944339378685238508652465258961L, 
0.0009945751278180853371459589003190170060195L,
0.0002460865533080482986379980477396709604161L,
0.00006124813505870482925854510513533374748170L,
0.00001528225940865187173257148763672202323739L,
3.817293264999839856461644621939730454697e-6L, 
9.539620338727961131520386834493459437942e-7L, 
2.384505027277329900036481867529949350418e-7L, 
5.960818905125947961244020793580122750392e-8L, 
1.490155482836504123465850663069862886479e-8L, 
3.725334024788457054819204018402423232893e-9L, 
9.313274324196681828717647350212198135680e-10L, 
2.328311833676505492001455975940495024830e-10L, 
5.820772087902700889243685989106305417312e-11L, 
1.455192189104198423592963224531842098381e-11L, 
3.637979547378651190237236355873273512646e-12L,
9.094947840263889282533118386949087538600e-13L,
2.273736845824652515226821577978691213830e-13L, 
5.684341987627585609277182967524068553057e-14L, 
1.421085482803160676983430714173953767870e-14L, 
3.552713691337113673298469534059342992146e-15L, 
8.881784210930815903096091386391386325609e-16L, 
2.220446050798041983999320094204653964237e-16L, 
5.551115124845481243723736590509430281672e-17L, 
1.387778780972523276283909490650022190772e-17L, 
3.469446952165922624744271496109334621950e-18L, 
8.673617380119933728342055067342951487907e-19L,
2.168404344997219785013910168320984576157e-19L,
5.421010862456645410918700404388633715063e-20L,
1.355252715610116458148523399682692832898e-20L,
3.388131789020796818085703100450836834031e-21L,
8.470329472546998348246992609182167522284e-22L,
2.117582368136194731844209439818002586942e-22L,
5.293955920339870323813912302918505586638e-23L,
1.323488980084899080309451025094498968432e-23L,
3.308722450212171588946956384314404809276e-24L,
8.271806125530344403671105616744072404010e-25L
};




long double clausen_series(long double theta)
{
   int i;
   long double tmp=0.0L;
   long double x = theta*theta/(4.0L*Pi*Pi);
   long double xn = 1.0L;
   for(i=0;i<40;i++)
   {
       xn = xn*x; 
       tmp = tmp + zeta_2n_minus1[i]*xn/((long double)(i+1)*(2*i+3) );
    };
    return tmp;
};






long double clausen(long double x)
{
  const long double x_cut = Pi * MY_LDBL_EPSILON;

  long double sgn = 1.0L;
  long double result;  

  if(x < 0.0) {
    x   = -x;
    sgn = -1.0L;
  };

  /* Argument reduction to [0, 2pi) */
  x = angle_restrict_pos(x);

  /* Further reduction to [0,pi) */
  if(x > Pi) {
    /* simulated extra precision: 2PI = p0 + p1 */
    x = 2.0L*Pi-x;
    sgn = -sgn;
  }

  if(x == 0.0) {
    result = 0.0L;
  }
  else if(x < x_cut) {
    result = x * (1.0L - logl(x));
  }
  else {
      
      result = x * (3.0L - logl(x*(1.0L-x*x/(4.0L*Pi*Pi))) - 2.0L*Pi/x*logl((2.0L*Pi+x)/(2.0L*Pi-x)) + clausen_series(x));
    };

  result *= sgn;

  return result;
};